## linuxcnc 2.7.5

=== src/Makefile ===
ifeq ($(origin KERNELRELEASE), undefined)
MAKEFLAGS += --warn-undefined-variables
endif

EXTRAFLAGS :=
EXTRA_DEBUG ?=

# see http://www.cmcrossroads.com/ask-mr-make/6535-tracing-rule-execution-in-gnu-make
# to trace make execution of make in more detail:
# make VV=1
ifeq ("$(origin VV)", "command line")
    OLD_SHELL := $(SHELL)
    SHELL = $(warning Building $@$(if $<, (from $<))$(if $?, ($? newer)))$(OLD_SHELL)
endif

# Delete the default suffix rules
.SUFFIXES:
.PHONY: default userspace modules clean modclean depclean install python pythonclean cscope cscopeclean

# A "trivial build" is one which should not include dependency information
# either because it should be usable before dependency information can be
# generated or when it is invalid (clean, docclean) or when running as root
# when the user must guarantee in advance that everything is built
# (setuid, install)
ifeq ($(MAKECMDGOALS),)
TRIVIAL_BUILD=no
else
ifeq ($(filter-out docclean clean setuid install tags swish,$(MAKECMDGOALS)),)
TRIVIAL_BUILD=yes
else
TRIVIAL_BUILD=no
endif
endif


# Beautify output
# ---------------------------------------------------------------------------
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If BUILD_VERBOSE equals 0 then the above command will be hidden.
# If BUILD_VERBOSE equals 1 then the above command is displayed.

ifeq ("$(origin V)", "command line")
  BUILD_VERBOSE = $(V)
endif
ifndef BUILD_VERBOSE
  BUILD_VERBOSE = 0
endif

ifeq ($(BUILD_VERBOSE),1)
  Q =
else
  Q = @
endif

ifeq "$(findstring s,$(filter-out --%, $(MAKEFLAGS)))" ""
ECHO=@echo
VECHO=echo
else
ECHO=@true
VECHO=true
endif

ifeq ($(BASEPWD),)
BASEPWD := $(shell pwd)
export BASEPWD
include Makefile.inc
ifeq ($(origin PYTHONPATH),undefined)
PYTHONPATH:=$(EMC2_HOME)/lib/python
else
PYTHONPATH:=$(EMC2_HOME)/lib/python:$(PYTHONPATH)
endif
export PYTHONPATH
else
include $(BASEPWD)/Makefile.inc
endif
ifeq ($(RTPREFIX),)
$(error Makefile.inc must specify RTPREFIX and other variables)
endif

cc-option = $(shell if $(CC) $(CFLAGS) $(1) -S -o /dev/null -xc /dev/null \
	     > /dev/null 2>&1; then echo "$(1)"; else echo "$(2)"; fi ;)

ifeq ($(origin KERNELRELEASE),undefined)
# When KERNELRELEASE is not defined, this is the userspace build.
# The "modules" target is the gateway to the kernel module build.
default: userspace modules
ifeq ($(RUN_IN_PLACE),yes)
ifneq ($(BUILD_SYS),uspace)
	@if [ -f ../bin/linuxcnc_module_helper ]; then if ! [ `stat -c %u ../bin/linuxcnc_module_helper` -eq 0 -a -u ../bin/linuxcnc_module_helper ]; then $(VECHO) "You now need to run 'sudo make setuid' in order to run in place."; fi; fi
else
	@if [ -f ../bin/rtapi_app ]; then if ! [ `stat -c %u ../bin/rtapi_app` -eq 0 -a -u ../bin/rtapi_app ]; then $(VECHO) "You now need to run 'sudo make setuid' in order to run in place with access to hardware."; fi; fi
endif
endif


# Print 'entering' all the time
MAKEFLAGS += w

# Create the variables with := so that subsequent += alterations keep it
# as a "substitute at assignment time" variable
TARGETS :=
PYTARGETS :=
GENERATED_MANPAGES :=

# Submakefiles from each of these directories will be included if they exist
SUBDIRS := \
    libnml/linklist libnml/cms libnml/rcs libnml/inifile libnml/os_intf \
    libnml/nml libnml/buffer libnml/posemath libnml \
    \
    rtapi/examples/timer rtapi/examples/semaphore rtapi/examples/shmem \
    rtapi/examples/extint rtapi/examples/fifo rtapi/examples rtapi \
    \
    hal/components hal/drivers hal/user_comps/devices hal/user_comps/mb2hal \
    hal/user_comps hal/user_comps/vismach hal/user_comps/vfs11_vfd hal/classicladder hal/utils hal \
    hal/user_comps/vfdb_vfd hal/user_comps/wj200_vfd \
    hal/user_comps/huanyang-vfd \
    \
    emc/usr_intf/axis emc/usr_intf/touchy emc/usr_intf/stepconf emc/usr_intf/pncconf \
    emc/usr_intf/gremlin \ emc/usr_intf/gscreen \
    emc/usr_intf/gmoccapy \
    emc/usr_intf emc/nml_intf emc/task emc/iotask emc/kinematics emc/tp emc/canterp \
    emc/motion emc/ini emc/rs274ngc emc/sai emc emc/pythonplugin \
    emc/motion-logger \
    \
    module_helper \
    \
    po \
    \
    ../docs/src ../docs/src/source-highlight \



ULAPISRCS := rtapi/$(RTPREFIX)_ulapi.c

# Each item in INCLUDES is transformed into a -I directive later on
# The top directory is always included
INCLUDES := .

USERSRCS :=
PROGRAMS :=

# When used like $(call TOxxx, ...) these turn a list of source files
# into the corresponding list of object files, dependency files,
# or both.  When a source file has to be compiled with special flags,
# TOOBJSDEPS is used.  Confusingly, TOOBJSDEPS includes preprocessed source
# file names, but this is what allows 'make src.i' to produce proper
# preprocessed source when src.c needs a customized compile flag.
# See Submakefile.skel for an example.
TOOBJS = $(patsubst %.cc,objects/%.o,$(patsubst %.c,objects/%.o,$(1)))
TODEPS = $(patsubst %.cc,objects/%.d,$(patsubst %.c,objects/%.d,$(1)))
TOOBJSDEPS = $(call TOOBJS,$(1)) $(call TODEPS, $(1)) $(patsubst %.cc,%.ii,$(patsubst %.c,%.i,$(1)))

SUBMAKEFILES := $(patsubst %,%/Submakefile,$(SUBDIRS))
-include $(wildcard $(SUBMAKEFILES))

# This checks that all the things listed in USERSRCS are either C files
# or C++ files
ASSERT_EMPTY = $(if $(1), $(error "Should be empty but is not: $(1)"))
$(call ASSERT_EMPTY,$(filter-out %.c %.cc, $(USERSRCS)))

ifeq ($(BUILD_PYTHON),yes)
$(call TOOBJS,$(PYSRCS)) : EXTRAFLAGS += -fPIC -fno-strict-aliasing
USERSRCS += $(PYSRCS)
endif

# Find the list of object files for each type of source file
CUSERSRCS := $(filter %.c,$(USERSRCS))
CXXUSERSRCS := $(filter %.cc,$(USERSRCS))
CUSEROBJS := $(call TOOBJS,$(CUSERSRCS))
CXXUSEROBJS += $(call TOOBJS,$(CXXUSERSRCS))

ifeq ($(TRIVIAL_BUILD),no)
# Find the dependency filenames, then include them all
DEPS := $(sort $(patsubst %.o,%.d,$(CUSEROBJS) $(CXXUSEROBJS)))
READ_DEPS = $(wildcard $(DEPS))
$(shell $(VECHO) 1>&2 Reading $(words $(READ_DEPS))/$(words $(DEPS)) dependency files)
-include $(READ_DEPS)
UNREAD_DEPS = $(filter-out $(READ_DEPS), $(DEPS))
$(shell $(VECHO) 1>&2 Done reading dependencies)
endif

# Each directory in $(INCLUDES) is passed as a -I directory when compiling.
INCLUDE := $(patsubst %,-I%, $(INCLUDES)) -I$(RTDIR)/include
ifeq ($(BUILD_PYTHON),yes)
INCLUDE += -I$(INCLUDEPY)
endif

# Compilation options.	Perhaps some of these should come from Makefile.inc? (CXXFLAGS now does)
INTEGER_OVERFLOW_FLAGS := -fwrapv
OPT := -Os $(INTEGER_OVERFLOW_FLAGS)
DEBUG := $(DEBUG) -g -Wall
CFLAGS := $(INCLUDE) $(OPT) $(DEBUG) $(EXTRA_DEBUG) -DULAPI -std=gnu99 -fgnu89-inline
CXXFLAGS := $(INCLUDE) $(CXXFLAGS)   $(EXTRA_DEBUG) -DULAPI $(DEBUG) $(OPT)

ifeq ($(RUN_IN_PLACE),yes)
LDFLAGS := -L$(LIB_DIR) -Wl,-rpath,$(LIB_DIR)
else
LDFLAGS := -Wl,-rpath-link,../lib
endif

# Rules to make .o (object) files
$(sort $(CUSEROBJS)) : objects/%.o: %.c
	$(ECHO) Compiling $<
	@mkdir -p $(dir $@)
	@rm -f $@
	$(Q)$(CC) -c $(CFLAGS) $(EXTRAFLAGS) \
		-MP -MD -MF "${@:.o=.d}" -MT "$@" \
		$< -o $@

$(sort $(CXXUSEROBJS)) : objects/%.o: %.cc
	$(ECHO) Compiling $<
	@mkdir -p $(dir $@)
	@rm -f $@
	$(Q)$(CXX) -c $(CXXFLAGS) $(EXTRAFLAGS) \
		-MP -MD -MF "${@:.o=.d}" -MT "$@" \
		$< -o $@

# Rules to make .i (preprocessed) files
$(sort $(patsubst %.c,%.i,$(CUSERSRCS))): %.i: %.c
	$(ECHO) Preprocessing $< to $@
	$(Q)$(CC) -dD $(CFLAGS) $(EXTRAFLAGS) -E $< -o $@

$(sort $(patsubst %.cc,%.ii,$(CXXUSERSRCS))): %.ii: %.cc
	$(ECHO) Preprocessing $< to $@
	$(Q)$(CXX) -dD $(CXXFLAGS) $(EXTRAFLAGS) -E $< -o $@

ifeq ($(TRIVIAL_BUILD),no)
configure: configure.in
	AUTOGEN_TARGET=configure ./autogen.sh

config.h.in: configure.in
	AUTOGEN_TARGET=config.h.in ./autogen.sh

config.status: configure
	if [ -f config.status ]; then ./config.status --recheck; else \
	    echo 1>&2 "*** linuxcnc is not configured.	Run './configure' with appropriate flags."; \
	    exit 1; \
	fi
endif

Makefile: config.h
config.h: config.h.in config.status
	@./config.status -q --header=$@

INFILES = \
        ../scripts/linuxcnc ../scripts/realtime \
	../scripts/haltcl ../scripts/rtapi.conf Makefile.inc Makefile.modinc \
	../tcl/linuxcnc.tcl ../scripts/halrun ../scripts/rip-environment \
	../scripts/linuxcncmkdesktop \
	 ../lib/python/nf.py \
	../share/desktop-directories/cnc.directory ../share/menus/CNC.menu \
	../share/applications/linuxcnc.desktop \
	../share/applications/linuxcnc-latency.desktop \
	../scripts/linuxcnc_var \

$(INFILES): %: %.in config.status
	@./config.status --file=$@

default: $(INFILES)

# For each file to be copied to ../include, its location in the source tree
# is listed here.  Note that due to $(INCLUDE), defined above, the include
# files in the source tree are the ones used when building linuxcnc.  The copy
# in ../include is used when building external components of linuxcnc.
HEADERS := \
    config.h \
    emc/ini/emcIniFile.hh \
    emc/ini/iniaxis.hh \
    emc/ini/initool.hh \
    emc/ini/initraj.hh \
    emc/ini/inihal.hh \
    emc/kinematics/cubic.h \
    emc/kinematics/kinematics.h \
    emc/kinematics/genhexkins.h \
    emc/kinematics/genserkins.h \
    emc/kinematics/pumakins.h \
    emc/tp/tc.h \
    emc/tp/tc_types.h \
    emc/tp/tcq.h \
    emc/tp/tp.h \
    emc/tp/tp_types.h \
    emc/tp/spherical_arc.h \
    emc/tp/blendmath.h \
    emc/motion/emcmotcfg.h \
    emc/motion/emcmotglb.h \
    emc/motion/motion.h \
    emc/motion/usrmotintf.h \
    emc/nml_intf/canon.hh \
    emc/nml_intf/canon_position.hh \
    emc/nml_intf/emctool.h \
    emc/nml_intf/emc.hh \
    emc/nml_intf/emc_nml.hh \
    emc/nml_intf/emccfg.h \
    emc/nml_intf/emcglb.h \
    emc/nml_intf/emcpos.h \
    emc/nml_intf/interp_return.hh \
    emc/nml_intf/interpl.hh \
    emc/nml_intf/motion_types.h \
    emc/nml_intf/debugflags.h \
    emc/rs274ngc/interp_internal.hh \
    emc/rs274ngc/interp_base.hh \
    emc/rs274ngc/rs274ngc.hh \
    hal/hal.h \
    hal/hal_parport.h \
    libnml/buffer/locmem.hh \
    libnml/buffer/memsem.hh \
    libnml/buffer/phantom.hh \
    libnml/buffer/physmem.hh \
    libnml/buffer/recvn.h \
    libnml/buffer/rem_msg.hh \
    libnml/buffer/sendn.h \
    libnml/buffer/shmem.hh \
    libnml/buffer/tcpmem.hh \
    libnml/cms/cms.hh \
    libnml/cms/cms_aup.hh \
    libnml/cms/cms_cfg.hh \
    libnml/cms/cms_dup.hh \
    libnml/cms/cms_srv.hh \
    libnml/cms/cms_up.hh \
    libnml/cms/cms_user.hh \
    libnml/cms/cms_xup.hh \
    libnml/cms/cmsdiag.hh \
    libnml/cms/tcp_opts.hh \
    libnml/cms/tcp_srv.hh \
    libnml/inifile/inifile.h \
    libnml/inifile/inifile.hh \
    libnml/linklist/linklist.hh \
    libnml/nml/cmd_msg.hh \
    libnml/nml/nml.hh \
    libnml/nml/nml_mod.hh \
    libnml/nml/nml_oi.hh \
    libnml/nml/nml_srv.hh \
    libnml/nml/nml_type.hh \
    libnml/nml/nmldiag.hh \
    libnml/nml/nmlmsg.hh \
    libnml/nml/stat_msg.hh \
    libnml/os_intf/_sem.h \
    libnml/os_intf/sem.hh \
    libnml/os_intf/_shm.h \
    libnml/os_intf/shm.hh \
    libnml/os_intf/_timer.h \
    libnml/os_intf/timer.hh \
    libnml/posemath/posemath.h \
    libnml/posemath/gotypes.h \
    libnml/posemath/gomath.h \
    libnml/posemath/sincos.h \
    libnml/rcs/rcs.hh \
    libnml/rcs/rcs_exit.hh \
    libnml/rcs/rcs_print.hh \
    libnml/rcs/rcsversion.h \
    rtapi/rtapi.h \
    rtapi/rtapi_app.h \
    rtapi/rtapi_atomic.h \
    rtapi/rtapi_bitops.h \
    rtapi/rtapi_bool.h \
    rtapi/rtapi_byteorder.h \
    rtapi/rtapi_device.h \
    rtapi/rtapi_firmware.h \
    rtapi/rtapi_gfp.h \
    rtapi/rtapi_io.h \
    rtapi/rtapi_limits.h \
    rtapi/rtapi_list.h \
    rtapi/rtapi_math.h \
    rtapi/rtapi_math_i386.h \
    rtapi/rtapi_math64.h \
    rtapi/rtapi_parport.h \
    rtapi/rtapi_pci.h \
    rtapi/rtapi_slab.h \
    rtapi/rtapi_stdint.h \
    rtapi/rtapi_common.h \
    rtapi/rtapi_ctype.h \
    rtapi/rtapi_errno.h \
    rtapi/rtapi_string.h

# Make each include file a target

=== debian/changelog ===
linuxcnc (1:2.7.5) unstable; urgency=medium

  * docs: update GladeVCP SpeedControl
  * docs: fix a typo in example gcode
  * docs: add some detail to Getting LinuxCNC
  * docs: clarify the intro to the python-interface documentation
  * docs: fix typo in python-interface docs
  * docs: fix information about opening a terminal
  * docs: add info about non network updates to Updating LinuxCNC
  * docs: update location of ISOs in Getting LinuxCNC
  * docs: fix command to add an apt source to Getting LinuxCNC
  * docs: fix typo in Getting Started guide
  * docs: new GladeVCP widget SpeedControl
  * docs: remove outdated remap information
  * docs: add more info on Classic Ladder compare and groups
  * docs: add info to pncconfig docs about editing a config
  * hm2_eth manpage: note the irq-coalesce trick
  * hal_input manpage: don't try to document udev rules syntax
  * linuxcncrsh manpage: remove wrong info about open g-code files

  * Axis GUI: fix File/Open on ini files with no [DISPLAY]PROGRAM_PREFIX
  * gmoccapy: small bug fixes (iconview and handlers)
  * gmoccapy: bugfix caused due to rests of alarm page
  * tklinuxcnc GUI: rebranding

  * carousel comp: Fix a bad initialisation in index mode
  * gantry comp: fix typo in docs
  * wj200 comp: warn on unhandled command-line arguments
  * xhc-hb04: accomodate prior connections to the
      motion.spindle-speed-out-rps-abs pin

  * shuttlexpress: clean up the manpage & asciidocs

  * GladeVCP: SpeedControl - changing limits do reset the increment
  * GladeVCP: SpeedControl - set default increment after setting a new adjustment
  * GladeVCP: SpeedControl - added widget icon
  * GladeVCP: tooledit.glade - corrected typo
  * GladeVCP: hal_sourceview - fix permissions of created files
  * GladevCP: gremlin - bugfix mouse button modes 4 and 6
  * GladeVCP: IconView - Bug due to double click
  * GladeVCP: Iconview - sensitivity bugfix
  * GladeVCP: Fix mdi error with tiny values
  * pyngcgui: find gcmc if not specified in ini
  * pyngcgui: remove mention of incorrect --height argument
  * hal_glib: add callLevel to EMC_TASK_STAT class, to fix file-loaded bug

  * stepconf: fix default pitch for A axis
  * stepconf: dynamically show how step scale is calculated
  * pncconf: add support for 5i24
  * pncconf: fix GUI's jog default settings
  * pncconf: fix user created stepper names error
  * pncconf: fix halui commands error
  * pncconf: fix spindle feedback signal error
  * pncconf: fix spindle display not working with encoder
  * pncconf: fix wrong inverted step/direction pin
  * pncconf: fix axis tests with invert step/pwm pins
  * pncconf: PID P calculation was wrong for steppers
  * pncconf: set PID P to a better default for stepper systems
  * pncconf: fix error when selecting both-home-x or y or

  * Pico configs: add lots of documenting comments
  * Pico configs: update format of tool table
  * configs: let it trigger a gladevcp bug

  * GM6-PCI driver: add support for PCI SubDevice ID 0x6ACC

  * rs274: work around boost::python bug
  * rs274: implement makeInterp for external users of librs274
  * interp: consistently set feed rate to 0 on M2/M30
  * interp: don't return potentially stacked data
  * interp: fix message for INTERP_FILE_NOT_OPEN (fixes #63)
  * interp: reset Interp and Canon state on Abort
  * interp: move end-of-program cleanup code to its own function
  * interp: fix build errors on Ubuntu 16.04
  * interp: don't return potentially stacked data
  * Task: fix a recent "surprise motion on abort" bug
  * Task: Fix serial number handling after 516deaef
  * Task: add drain_interp_list
  * Task: simplify handling of emcCommand
  * Task: only turn off the spindle once, when entering Estop
  * Task: only call emcTaskPlanInit() once during startup
  * Task: don't call emcAbortCleanup() in emcIoAbort()
  * Task: fixup indentation
  * rtapi (sim): flush stdout/stderr after rtapi_print()
  * rtapi parport: make all inline functions static
  * motion: remove overruns parameter
  * motion: remove heuristic delay warning
  * linuxcncsrv: ioctl(FIONREAD) wants int*, not ulong*
  * glcanon: is_lathe() is a function
  * HAL: fix comments describing HAL thread & funct times

  * tests: longer timeout in halui mdi test
  * tests: hm2-idrom: exit early when a test fails
  * tests: compile an example user of librs274
  * tests: add comments to motion-logger/basic 'expected' file
  * tests: add a test of STARTUP_GCODE vs Abort
  * tests: add a test to reproduce the g5x/abort preview problem

  * src/configure: detect potential readline license conflict
  * src/configure: fix a typo in a hep message
  * debian/configure: modernize usage/help message
  * debian/configure: add info about kernel
  * platform-is-supported: detect OS in a more portable way
  * rip-environment: rebranding
  * build: make failure copying images an error
  * packaging: interface with udev better

 -- Sebastian Kuzminsky <seb@highlab.com>  Tue, 12 July 2016 21:47:18 -0600

linuxcnc (1:2.7.4) unstable; urgency=medium

  * docs: update hm2_eth manpage with supported boards
  * docs: fix hostmot2 manpage markup
  * docs: update gs2 vfd docs with new command-line args
  * docs: update pyvcp docs (labels, leds, buttons)
  * docs: improve info on installing preempt-rt kernel
  * docs: add warning about entering a root password during install
  * docs: improve contributing intructions
  * docs: add a bit more info on ngcgui
  * docs: update max AIO from 16 to 64 in motion manpage 
  * docs: update homing diagram (dxf and image)
  * docs: clarify homing variable names
  * docs: add missing keyboard short cuts to Axis documentation
  * docs: clarify what "option userspace yes" means to halcompile
  * docs: add info about min and max soft limits
  * docs: add mb2hal manpage and documentation
  * docs: add a link to the github bug tracker
  * docs: github is more official now
  * docs: fix a broken links
  * docs: fix a couple of places to note nine axes or planes supported


=== debian/control ===
Source: linuxcnc
Section: misc
Priority: extra
Maintainer: Sebastian Kuzminsky <seb@highlab.com>
Build-Depends: debhelper (>= 6),
    libudev-dev,iptables, , dvipng,texlive-extra-utils,texlive-latex-recommended,texlive-fonts-recommended,ghostscript,imagemagick,texlive-lang-polish,texlive-font-utils,kmod,dh-python,
    tcl8.6-dev, tk8.6-dev,
    libxaw7-dev, libncurses-dev, libreadline-gplv2-dev,
    asciidoc (>= 8.5), source-highlight, dblatex (>= 0.2.12), xsltproc, groff,
    docbook-xsl,
    python, python-dev, python-tk, python-lxml,
    libglu1-mesa-dev, libgl1-mesa-dev | libgl1-mesa-swx11-dev,
    libgtk2.0-dev, gettext, autoconf, libboost-python-dev,
    texlive-lang-cyrillic, texlive-lang-french,
    texlive-lang-spanish, texlive-lang-german, netcat,
    libmodbus-dev (>= 3.0), libusb-1.0-0-dev, procps, psmisc,
    graphviz, inkscape
Standards-Version: 2.1.0

Package: linuxcnc-uspace-dev
Architecture: any
Conflicts: linuxcnc-sim-dev, linuxcnc-dev
Depends: g++, ,
    python (>= 2.7), python (<< 2.8),
    ${python:Depends}, ${misc:Depends},
    linuxcnc-uspace (= ${binary:Version}),
    yapps2-runtime
Section: libs
Description: PC based motion controller for real-time Linux
 LinuxCNC is the next-generation Enhanced Machine Controller which
 provides motion control for CNC machine tools and robotic
 applications (milling, cutting, routing, etc.).
 .
 This package includes files needed to build new realtime components and
 alternate front-ends for linuxcnc

Package: linuxcnc-uspace
Conflicts: linuxcnc-sim, linuxcnc
Architecture: any
Recommends: linuxcnc-doc-en | linuxcnc-doc, hostmot2-firmware-all, linux-image-rt-amd64 [linux-amd64], linux-image-rt-686-pae [linux-i386]
Depends: ${shlibs:Depends}, libudev-dev,iptables,
    tcl8.6, tk8.6, bwidget (>= 1.7), libtk-img (>=1.13),
    python (>= 2.7), python (<< 2.8),
    ${python:Depends}, ${misc:Depends},
    python2.7-tk,
    python2.7-gnome2 | python-gnome2,
    python2.7-glade2 | python-glade2,
    python2.7-numpy | python-numpy,
    python2.7-imaging | python-imaging,
    python2.7-imaging-tk | python-imaging-tk,
    python-gtksourceview2,
    python-vte,
    python-gst0.10, gstreamer0.10-plugins-base,
    python-xlib, python-gtkglext1, python-configobj,
    tclreadline, procps, psmisc, module-init-tools | kmod, tclx,
    mesa-utils, blt
Description: PC based motion controller for real-time Linux
 LinuxCNC is the next-generation Enhanced Machine Controller which
 provides motion control for CNC machine tools and robotic
 applications (milling, cutting, routing, etc.).

Package: linuxcnc-doc-en
Provides: linuxcnc-doc
Architecture: all
Depends: ${misc:Depends}
Suggests: pdf-viewer
Description: PC based motion controller for real-time Linux
 LinuxCNC is the next-generation Enhanced Machine Controller which
 provides motion control for CNC machine tools and robotic
 applications (milling, cutting, routing, etc.).
 .
 This package contains the documentation in English.

Package: linuxcnc-doc-fr
Provides: linuxcnc-doc
Architecture: all
Depends: ${misc:Depends}
Suggests: pdf-viewer
Description: PC based motion controller for real-time Linux
 LinuxCNC is the next-generation Enhanced Machine Controller which
 provides motion control for CNC machine tools and robotic
 applications (milling, cutting, routing, etc.).
 .
 This package contains the documentation in French.

Package: linuxcnc-doc-es
Provides: linuxcnc-doc
Architecture: all
Depends: ${misc:Depends}
Suggests: pdf-viewer
Description: PC based motion controller for real-time Linux
 LinuxCNC is the next-generation Enhanced Machine Controller which
 provides motion control for CNC machine tools and robotic
 applications (milling, cutting, routing, etc.).
 .
 This package contains the documentation in Spanish.

=== debian/rules ===
#!/usr/bin/make -f
# Simple set of debian/rules that uses debhelper.
# Based on an example by Joey Hess. 
# extended by Paul Corner, Alex Joni, Chris Radek, Jeff Epler (in cronological order)

# Copyright (C) 2006 Jeff Epler
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# When used to produce a debian package, this file is a script "used to
# control compilation and installation of the executable"

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

kernel_version = uspace

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
endif


debian/control:
	echo '# THIS FILE IS AUTO-GENERATED FROM control.in' > debian/control
	sed -e 's/@@KVERSION@@/$(kernel_version)/g' \
	    debian/control.in >> debian/control

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp:
	dh_testdir

# Add here commands to compile the package.
	cd src && ./autogen.sh
ifeq "$(kernel_version)" "uspace"
	cd src && ./configure --prefix=/usr --sysconfdir=/etc --mandir=/usr/share/man --with-realtime=uspace --enable-build-documentation=pdf --disable-check-runtime-deps
else
	cd src && ./configure --prefix=/usr --sysconfdir=/etc --mandir=/usr/share/man --with-realtime=/usr/realtime-$(kernel_version) --enable-build-documentation=pdf --disable-check-runtime-deps
endif
	(cd src; $(MAKE) $(MAKEFLAGS) && $(MAKE) $(MAKEFLAGS) docs)
	touch build-stamp

clean: debian/control
	dh_testdir
	dh_testroot
	rm -f build-stamp

	cd src && ./autogen.sh
ifeq "$(kernel_version)" "uspace"
	cd src && ./configure --prefix=/usr --sysconfdir=/etc --mandir=/usr/share/man --with-realtime=uspace --enable-build-documentation=pdf --disable-check-runtime-deps
else
	cd src && ./configure --prefix=/usr --sysconfdir=/etc --mandir=/usr/share/man --with-realtime=/usr/realtime-$(kernel_version) --enable-build-documentation=pdf --disable-check-runtime-deps
endif
	cd src && $(MAKE) clean -s
	rm -f Makefile.inc
	rm -f src/config.log src/config.status

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
# start the install
	mkdir -p debian/tmp
	-(cd debian/extras && cp -a * ../tmp)
	(cd src; export DESTDIR=`pwd`/../debian/tmp; $(MAKE) $@)
	mkdir -p debian/tmp/usr/lib debian/tmp/usr/include/linuxcnc
	cp lib/*.a debian/tmp/usr/lib
	mkdir -p debian/tmp/usr/share/doc/linuxcnc-dev
	mv debian/tmp/usr/share/doc/linuxcnc/LinuxCNC_Developer_Manual.pdf \
		debian/tmp/usr/share/doc/linuxcnc-dev/
	cp docs/html/gcode*.html debian/tmp/usr/share/doc/linuxcnc/
	rm -rf debian/tmp/usr/share/doc/linuxcnc/html
	-rm debian/tmp/linuxcnc*.files
	-rm -f debian/tmp/usr/share/doc/linuxcnc/examples/sample-configs/*/*position*.txt
	(cd debian/tmp/usr/share/doc/linuxcnc/examples; \
	    ln -sf ../../../linuxcnc/ncfiles ./nc_files)
	dh_movefiles
	if [ `find debian/tmp -type f | wc -c` != 0 ]; then \
		echo "Files exist in debian/tmp, but should not:"; \
		find debian/tmp -type f; \
		exit 1; \
	fi

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_installexamples
	dh_installman
	dh_installmime
	dh_link
	dh_strip
	dh_compress -X.pdf -X.txt -X.hal -X.ini -X.clp -X.var -X.nml -X.tbl -X.xml -Xsample-configs
	dh_fixperms -X/linuxcnc_module_helper -X/rtapi_app
	dh_python2
	dh_makeshlibs
	dh_installdeb
	cat debian/linuxcnc-uspace/DEBIAN/shlibs debian/shlibs.pre > debian/shlibs.local
	dh_shlibdeps -l debian/linuxcnc-uspace/usr/lib
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

debian/rules: debian/configure debian/*.in
	debian/configure uspace

## linuxcnc 2.7.13

=== debian/changelog ===
linuxcnc (1:2.7.13) unstable; urgency=medium

  * docs: correct g33.1 warning and text
  * docs: describe motion.program-line in motion manpage
  * docs: remove last mention of pins from PID description in rtcomps
  * docs: update the PID section of rtcomps (#388)
  * docs: add missing num_sserials info to hm2 manpage
  * docs: add missing .tool-prep-index parameter to io manpage
  * docs: add some docstrings to the linuxcnc python module
  * docs: make the tool table docs more findable
  * docs: fix a spelling error in bldc manpage
  * docs: M19 is no longer an unused M-code

  * axis GUI: fix file open dialog with recent py/tcl (#414)

  * gscreen industrial GUI: fix DRO display if VCP panel added
  * gscreen GUI: fix error if gstreamer library missing

  * stepconf: fix lathe configs; Z axis must be 2 not 1

  * pncconf: fix lathe configs z axis should be 2 not 1
  * pncconf: fix tandem stepper command signals
  * pncconf: fix control type with tandem axes

  * gladevcp: fix a warning about icon size

  * interp: require < after # for named parameters (#424)

  * hm2 7i90: fix indentation for legibility
  * halrmt: fix confusing indentation
  * classicladder: fix indentation

  * io: fix a misleading comment
  * io: update the status buffer when prepping the loaded tool
  * io: set the HAL pins/params even for the loaded tool
  * io: remove an incorrect debug message

  * test: add tests of reloading the loaded tool
  * test: add a test for interp variable name bug (#424)

  * packaging: use dh_prep instead of deprecated 'dh_clean -k'
  * packaging: remove trailing whitespace in changelog
  * packaging: note copyright on yapps

 -- Sebastian Kuzminsky <seb@highlab.com>  Tue, 08 May 2018 21:12:41 -0600

linuxcnc (1:2.7.12) unstable; urgency=medium

  * docs: clean up net commands in orient docs
  * docs: fix hyphen/minus confusion in manpages
  * docs: fix axis name error in gmoccapy "Probe Information"
  * docs: add G20/G21 unit info to G-code Quick Ref
  * docs: make G96/G97 comments consistent
  * docs: [TRAJ]HOME is ignored on trivial kinematics machines
  * docs: fix a typo in mux_generic manpage
  * docs: improve docstring for `linuxcnc.wait_complete()`
  * docs: improve .motion-type pin info in motion manpage
  * docs: add G99 to G-code Quick Ref
  * docs: new Chinese translations
  * docs: fixup capitalization of variables in Homing docs
  * docs: clarify valid values of HOME_OFFSET
  * docs: add Chinese translation
  * docs: improve milltask manpage
  * docs: remove mention of ancient "bfloat" program from hm2_7i43 manpage
  * docs: fix typos here and there

  * axis gui: remove a startup-time debug message
  * axis gui: fix cursor keys in MDI window
  * axis gui: add 'Select Max velocity' key bindings in quick ref
  * axis gui: fix jog speed key bindings (#268)
  * axis gui: don't try to convert unicode to unicode
  * gmoccapy gui: fix bug with lathe DRO size and missing gst
  * gscreen gui: fix DRO display with VCP in 'industrial' config

  * limit3: complete rewrite, much better behavior

  * stepconf: restore translation

  * pncconf: fix stepgen MAXVEL and MAXACCEL setting with backlash
  * pncconf: add internal firmware for g540x2
  * pncconf: add internal data for 7i92 and 7i80HD cards
  * pncconf: restore translation

  * hm2: stop a spurious "IOPort ignored" warning
  * hm2: fix a copy/paste bug in an error message
  * hm2 sserial: quiet excessive warning messages
  * hm2 sserial: fix bug with spurious port shutdown
  * hm2 dpll: fix even-numbered timers (#211)
  * hm2 7i34, 7i90: don't silently fail with blank config strings

  * puma: update puma kins, vismach model, and configs for D6 joint

  * glcanon: fix a "DRO disappears" bug with wrapped rotaries

  * linuxcnctop: decrease CPU usage and memory leakiness
  * linuxcnctop: split long lines at whitespace
  * linuxcnctop: fix display of some sequence-type data

  * sim_pin: improve help for signals with no writers

  * motion: cancel unlock requests when motion disabled

  * rtapi: fix a sched_setaffinity error on uspace with old glibc

  * tests: protect sim.var file, dpkg removes *.orig
  * tests: increased coverage of limit3 tests

  * src/configure: verify python's pango & cairo modules are installed

  * build: rebuild gmoccapy.pot
  * fix a typo in maintainer docs

  * packaging: add Keywords to all .desktop files
  * packaging: validate desktop files
  * packaging: update debian/copyright to conform to DEP-5
  * packaging: improve short descriptions
  * packaging: build-depend on intltool (for buiding gmoccapy.pot)

 -- Sebastian Kuzminsky <seb@highlab.com>  Wed, 24 Jan 2018 21:59:53 -0700

linuxcnc (1:2.7.11) unstable; urgency=medium

  * doc changes for the transition to github
  * carousel: fix a bug with tool number of zero
  * axis/gremlin: a better way to avoid leaking files
  * test that the Python interpreter prints the right errors

 -- Sebastian Kuzminsky <seb@highlab.com>  Thu, 27 Jul 2017 22:36:58 -0600

linuxcnc (1:2.7.10) unstable; urgency=medium

  * docs: document [EMCMOT]COMM_TIMEOUT
  * docs: teach buildsystem to generate manpages from asciidoc source
  * docs: add info about the Touchy radio buttons
  * docs: improve some hm2_bspi manpages

  * gmoccapy: added Num_Pad jogging
  * image-to-gcode: work around gratuitous breakage in PIL

  * GladeVCP: don't exit if CombiDRO fails to poll status

  * hy_vfd: add --motor-poles, to set PD143
  * hy_vfd: add --base-frequency to set PD004 on the VFD
  * hy_vfd: document PD004/base-freq better in the manpage
  * hy_vfd: fix some typos in --help output and comments

  * add a driver for the Huanyang GT series VFD

  * hm2_eth: add support for Mesa 7i93 AnyIO ethernet board
  * hm2_sserial: Fix a bug where the second port would not work if the
      first was disabled

  * gcodemodule: make interp really close part program
  * pluto: use rtapi's fabs() instead of the kernel's abs()
  * steptest: don't change position-cmd when not running



=== debian/control ===
--- 
+++ 
@@ -14,7 +14,9 @@
     texlive-lang-cyrillic, texlive-lang-french,
     texlive-lang-spanish, texlive-lang-german, netcat,
     libmodbus-dev (>= 3.0), libusb-1.0-0-dev, procps, psmisc,
-    graphviz, inkscape
+    graphviz, inkscape,
+    intltool,
+    desktop-file-utils,
 Standards-Version: 2.1.0
 
 Package: linuxcnc-uspace-dev
@@ -26,7 +28,7 @@
     linuxcnc-uspace (= ${binary:Version}),
     yapps2-runtime
 Section: libs
-Description: PC based motion controller for real-time Linux
+Description: motion controller for CNC machines and robots (development files)
  LinuxCNC is the next-generation Enhanced Machine Controller which
  provides motion control for CNC machine tools and robotic
  applications (milling, cutting, routing, etc.).
@@ -50,11 +52,11 @@
     python2.7-imaging-tk | python-imaging-tk,
     python-gtksourceview2,
     python-vte,
-    python-gst0.10, gstreamer0.10-plugins-base,
+    python-gst0.10,gstreamer0.10-plugins-base,
     python-xlib, python-gtkglext1, python-configobj,
     tclreadline, procps, psmisc, module-init-tools | kmod, tclx,
     mesa-utils, blt
-Description: PC based motion controller for real-time Linux
+Description: motion controller for CNC machines and robots
  LinuxCNC is the next-generation Enhanced Machine Controller which
  provides motion control for CNC machine tools and robotic
  applications (milling, cutting, routing, etc.).
@@ -64,7 +66,7 @@
 Architecture: all
 Depends: ${misc:Depends}
 Suggests: pdf-viewer
-Description: PC based motion controller for real-time Linux
+Description: motion controller for CNC machines and robots (English documentation)
  LinuxCNC is the next-generation Enhanced Machine Controller which
  provides motion control for CNC machine tools and robotic
  applications (milling, cutting, routing, etc.).
@@ -76,7 +78,7 @@
 Architecture: all
 Depends: ${misc:Depends}
 Suggests: pdf-viewer
-Description: PC based motion controller for real-time Linux
+Description: motion controller for CNC machines and robots (French documentation)
  LinuxCNC is the next-generation Enhanced Machine Controller which
  provides motion control for CNC machine tools and robotic
  applications (milling, cutting, routing, etc.).
@@ -88,7 +90,7 @@
 Architecture: all
 Depends: ${misc:Depends}
 Suggests: pdf-viewer
-Description: PC based motion controller for real-time Linux
+Description: motion controller for CNC machines and robots (Spanish documentation)
  LinuxCNC is the next-generation Enhanced Machine Controller which
  provides motion control for CNC machine tools and robotic
  applications (milling, cutting, routing, etc.).

=== debian/rules ===
--- 
+++ 
@@ -65,10 +65,19 @@
 install: build
 	dh_testdir
 	dh_testroot
-	dh_clean -k
+	dh_prep
 	dh_installdirs
 # start the install
 	mkdir -p debian/tmp
+
+	# Version 0.22 and newer of the desktop-file-validate program
+	# (in Jessie and newer) can deal with multiple files specified
+	# on the command line.	Version 0.20 (in Wheezy) says it can,
+	# but can't.  So feed it the files one by one.
+	for F in $(shell find debian/extras/ -name *.desktop); do \
+		desktop-file-validate $$F; \
+	done
+
 	-(cd debian/extras && cp -a * ../tmp)
 	(cd src; export DESTDIR=`pwd`/../debian/tmp; $(MAKE) $@)
 	mkdir -p debian/tmp/usr/lib debian/tmp/usr/include/linuxcnc
